/*
 * Copyright (C) 2021 eichehome
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package utils;

import java.io.IOException;
import java.io.ObjectOutputStream;

/**
 *
 * @author eichehome
 */
public class Client {

    private final ObjectOutputStream out;
    private final Thread pusher;
    private final Thread reciver;

    public Client(ObjectOutputStream out, Thread pusher, Thread reciver) {
        this.out = out;
        this.pusher = pusher;
        this.reciver = reciver;
    }

    public void writeMessage(Message message) {
        try {
        this.out.writeObject(message);
        } catch (IOException ex) {
            System.err.println("Cliet: Fehler: " + ex);
        }
    }

    public ObjectOutputStream getOutputStream() {
        return this.out;
    }

    public Thread getPusher() {
        return this.pusher;
    }
    
    public Thread getReciver() {
        return this.reciver;
    }
}
